#include <asm/unistd_64.h>
#include <stdint.h>
#include <unistd.h>

ssize_t my_write(int fd, const void *buf, size_t count) {
  int64_t result;
  asm volatile (
      "syscall"
      : /* outputs */
        "=a" (result)
      : /* inputs */
        "a" (__NR_write), // rax = syscall number
        "D" (fd),         // rdi = arg1
        "S" (buf),        // rsi = arg2
        "d" (count)       // rdx = arg3
      : /* clobbers */
        "cc",
        "r11",
        "rcx"
      );
}

void my_putchar(int c) {
  char ch = c;
  my_write(STDOUT_FILENO, &ch, 1);
}

static const char msg1[] = "This is ";
static const char msg2[] = "broken.\n";

int main() {
  write(STDOUT_FILENO, msg1, sizeof(msg1) - 1);
  my_putchar('n');
  my_putchar('o');
  my_putchar('t');
  my_putchar(' ');
  write(STDOUT_FILENO, msg2, sizeof(msg2) - 1);
  return 0;
}
